Edgewall Software

Version 2 (modified by Christian Boos, 14 years ago) ( diff )

minor edits

Trac and Subversion

Trac supports the Subversion VersioningSystemBackend since day one. Actually, Trac was even named svntrac back then!

This page is intended to collect all the specific tips and tricks about Subversion support in Trac. This is not the place for general Subversion help. You can get more support options elsewhere.

At the time of this writing, the preferred Subversion version for Trac is still 1.2.3. If you are willing to make a few changes to the stock 1.3.0, that version works also pretty well.

Building Subversion

The point is not to repeat the excellent build instructions found elsewhere, but rather to clarify the general approach: Trac actually needs the SWIG bindings for Subversion that are bundled with the Subversion distribution. In order to build them, you (obviously) need to build first Subversion, then the bindings.

  • Read the INSTALL file that sits at toplevel of the Subversion source distribution
  • Do ./configure ...; make; make install
  • Read ./subversion/bindings/swig/INSTALL in order to build the bindings. In particular, pay attention to the version of SWIG which can be required (1.3.0 comes with pregenerated wrappers, though).
  • Do make swig-py; make install-swig-py
  • Adapt your PYTHONPATH so that it contains the svn-python folder (the one containing the svn and libsvn packages).

Trac and specific Subversion versions

Trac and Subversion 1.0

This is the oldest supported Subversion version.

Trac and Subversion 1.1

This release introduced the fsfs repository backend, which is to be preferred over the bdb one (see #571 for example). When creating a repository with this Subversion version, take care of using the --fs-type fsfs switch with the svnadmin create command. Version 1.1.4 is the last stable one for that maintenance branch.

Trac and Subversion 1.2

This release makes the fsfs storage the default. Version 1.2.3 is the last stable one for that maintenance branch.

Trac and Subversion 1.3

This is the newest major release for Subversion, and it is currently support by Trac 0.9.x and beyond, with a few caveats.

Trac and Subversion 1.3.0

There are a few known issues with the stock 1.3.0 version:

  • Issue #2472 (spurious exception)
    which can be fixed by applying this patch to subversion/bindings/swig/python/svn/core.py
  • Issue #2620 (memory leak)
    which can be fixed by applying this patch to subversion/bindings/swig/python/libsvn_swig_py/swigutil_py.c.

With those fixes, I've been able to use the Subversion backend flawlessly "in production", since end of January 2006.

However, some people are seeing yet another problem, which requires one more fix:

  • Issue #2611 (intermittent fatal error)
    which can be fixed by applying this patch to subversion/bindings/swig/include/proxy_apr.swg. Note that this requires to regenerate the SWIG bindings, as explained in here. It should be emphasized that a compatible version of SWIG must be used (1.3.24, 1.3.25 and possibly(?) 1.3.28).

Asking for More Support About Subversion

Note: See TracWiki for help on using the wiki.